/*********************************************************************************
 *
 * Razor! Engine - A modular C++ presentation engine
 *
 * $Id: SonyClieCanvas.h,v 1.5 2003/05/30 12:30:21 teacy Exp $
 *
 * Copyright (c) 2000-2003 Tilo Christ. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the  "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the Software 
 * is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all 
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 **********************************************************************************/

#ifndef SONYCLIE_CANVAS_H
#define SONYCLIE_CANVAS_H

#include "RazorSections.h"

#ifdef SUPPORT_CLIE
#include <SonyCLIE.h>
#include "gfx/Canvas.h"


namespace prvrazor
{


/**
 * A Canvas that supports special features in Sony Clie devices.
 */
class SonyClieCanvas : public Canvas
{
	public:

	SonyClieCanvas(UInt16 hrRefnum, Coord width, Coord height, CoordSystem coordSystem) SEC_RAZOR_INIT;
	SonyClieCanvas(UInt16 hrRefnum) SEC_RAZOR_INIT;
	
	~SonyClieCanvas() SEC_RAZOR_INIT;

	void setOSCanvas() const;
	Boolean setForegroundColor(const Color color) const;
	Boolean setBackgroundColor(const Color color) const;

	UInt16 hrRefnum;

	private:
	WinHandle offscreenWindow;
};

}

#endif

#endif
